image: docker:19.03.5
services:
  - docker:19.03.5-dind

stages:
  - Build
  - Push

Build:
  stage: Build
  before_script: []
  script:
    - mkdir data/
    - docker build --compress -t proxy .
    - docker save --output data/image.tar proxy
  artifacts:
    name: image
    paths:
      - data/

# ... existing code ...

before_script:
  - apk add python3
  - pip3 install awscli==1.18.8
  - docker load --input data/image.tar
  - $(aws ecr get-login --no-include-email --region us-east-1)

# ... existing code ...

Push Dev:
  stage: Push
  script:
    - docker tag proxy:latest $ECR_REPO:dev
    - docker push $ECR_REPO:dev
  rules:
    - if: "$CI_COMMIT_BRANCH == 'master'"

Push Release:
  stage: Push
  script:
    - export TAGGED_ECR_REPO=$ECR_REPO:$(echo $CI_COMMIT_TAG | sed 's/-release//')
    - docker tag proxy:latest $TAGGED_ECR_REPO
    - docker push $TAGGED_ECR_REPO
    - docker tag $TAGGED_ECR_REPO $ECR_REPO:latest
    - docker push $ECR_REPO:latest
  rules:
    - if: "$CI_COMMIT_TAG =~ /^*-release$/"
# image: docker:19.03.5

# # service that allows uses docker within docker

# services:
#   - docker:19.03.5-dind

# stages:
#   - Build
#   - Push

# #Before script, this is set the of scripts that runs before Push Dev, and Push Release
# #based on the principal of Do Not Repeat Yourself
# # 1. python 3 installed on the build image that's needed on AWS CLI that would be used to push our image
# #2. install awscli
# #3. loads docker iamge from artificat in the previous job
# #4. create docker login command to log into ecr
# before_script:
#   - apk add python3
#   - pip3 install awscli==1.18.8
#   - docker load --input data/image.tar
#   - $(aws ecr get-login --no-include-email --region us-east-1)

# #first jobs = build
# # before script - this says "do not run before_script, because we don't need it for this job"
# #artifcat is a way to pass files from one job to the next job. Artifacts make themselves available for future jobs
# Build:
#   stage: Build
#   before_script: []
#   script:
#     - mkdir data/
#     - docker build --compress -t proxy .
#     - docker save --output data/image.tar proxy
#   artifacts:
#     name: image
#     paths:
#       - data/

# # dev job
# #script docker tag - tags proxy latest with repositiory name followed by dev
# #docker push - push reposinitory to AWS ECR
# # the if statement - this rule says only run the above job when the commit branch is master
# Push Dev:
#   stage: Push
#   script:
#     - docker tag proxy:latest $ECR_REPO:dev
#     - docker push $ECR_REPO:dev
#   rules:
#     - if: "$CI_COMMIT_BRANCH == 'master'"

# #release job
# #get CI commit tag which is a var, use sed to strip of /-relase from tag, so finally the output would be the version number e.g., 1.0.2. We then append the version number to the ECR repo and assign it to a var called ECR_REPO
# # export tag - created tag from commit tag name
# #docker tag proxy - tagged the above with docker tag, tagged with ECR repo and added the version number in
# #docker push this docker image
# #docker tag - anytime you push a new relase tag it with latest tag and make it latest release
# #docker - push the latest tag the same way pushed the version tagged
# # if CI commit tag = any naming pattern ending -release. only tags that end with release will tring this build
# Push Release:
#   stage: Push
#   script:
#     - export TAGGED_ECR_REPO=$ECR_REPO:$(echo $CI_COMMIT_TAG | sed 's/-release//')
#     - docker tag proxy:latest $TAGGED_ECR_REPO
#     - DOCKER push $TAGGED_ECR_REPO
#     - docker tag $TAGGED_ECR_REPO $ECR_REPO:latest
#     - docker push $ECR_REPO:latest

#   rules:
#     if: "$CI_COMMIT_TAG =~/^*-release$/"
